import psyco, ode, time, levelset1, levelset2, levelset3
psyco.full()
from glLib import *
from const import *
from random import *

pygame.init()

Screen = (800,600)
Window = glLibWindow(Screen,caption="Bridge",multisample=True)

##glLibPrecompileBuiltinShaders()

View2D = glLibView2D((0,0,Screen[0],Screen[1]))
View3D = glLibView3D((0,0,Screen[0],Screen[1]),45,0.1,200)

WorldCube = glLibObject("data/objects/world.obj",GLLIB_MIPMAP_BLEND,GLLIB_FILTER)
LavaCube = glLibObject("data/objects/lava.obj",GLLIB_MIPMAP_BLEND,GLLIB_FILTER)
SkySphere = glLibSphere(10,32,True)
PlayerSphere = glLibSphere(twentyfourth,32,True)
LavaSphere = glLibSphere(fortyeighth,8,True)

Font24 = pygame.font.SysFont("Times New Roman",24)
Font36 = pygame.font.SysFont("Times New Roman",36)

world = ode.World()
world.setGravity( (0,-gravity,0) )

collidespace = ode.Space()
collidelavafloor = ode.GeomPlane(collidespace, (0,1,0), 0.5-twelfth)

from textureload import *
from objects import LavaBombTrail, plane, platform, arrow, cube
from customshaders import NormalShader, TextureShader, LightTextureShader
import classes
classes.send([LavaSphere,PlayerSphere,platform,collidespace,world])
from classes import Player, LavaBomb, Block

glEnable(GL_LIGHT0)
glEnable(GL_LIGHT1)
glEnable(GL_LIGHT2)

glLightfv(GL_LIGHT0,GL_DIFFUSE,[1,1,1,1])
glLightfv(GL_LIGHT0,GL_SPECULAR,[1,1,1,1])
glLightfv(GL_LIGHT1,GL_DIFFUSE,[0.01,0.01,0.01,1])
glLightfv(GL_LIGHT1,GL_SPECULAR,[0.01,0.01,0.01,1])
glLightfv(GL_LIGHT2,GL_DIFFUSE,[1,1,1,1])
glLightfv(GL_LIGHT2,GL_SPECULAR,[1,1,1,1])
glLightfv(GL_LIGHT2,GL_LINEAR_ATTENUATION,1)
glLightfv(GL_LIGHT2,GL_QUADRATIC_ATTENUATION,1)

nearworld = ode.GeomBox(collidespace, lengths=(20,20,20))
farworld = ode.GeomBox(collidespace, lengths=(20,20,20))
nearworld.setPosition((0,-9,-10))

currentlevel = 0
currentlevelset = 1
starttime = 0.0
endtime = 0.0
score = 0
tries = 0

Player1 = Player()
camerarot = 25
cameraradius = 1.67 #hypot(0.75,1.5)
def GetInput():
    global currentlevel, tries
    mrel = pygame.mouse.get_rel()
    mpress = pygame.mouse.get_pressed()
    key = pygame.key.get_pressed()
    for event in pygame.event.get():
        if event.type == QUIT or (event.type == KEYDOWN and event.key == K_ESCAPE):
            pygame.quit()
            sys.exit()
        elif event.type == KEYDOWN and Player1.dead:
            currentlevel -= 1
            LevelUp(True)
            tries += 1
    if Player1.onplatform:
        if key[K_LEFT]: Player1.direction -= 6
        if key[K_RIGHT]: Player1.direction += 6
        s = 2.0
        if key[K_UP]:
            force = [s*cos(radians(Player1.direction+90)),0,s*sin(radians(Player1.direction+90))]
            Player1.body.addForce(force)
        if key[K_LSHIFT] or key[K_RSHIFT] or key[K_SPACE]:
            Player1.body.addForce((0,10,0))
    if key[K_KP8] and camerarot < 80: camerarot += 1
    if key[K_KP2] and camerarot > 10: camerarot -= 1
    if key[K_KP_PLUS] and cameraradius < 3.0: cameraradius += 0.1
    if key[K_KP_MINUS] and cameraradius > 1.0: cameraradius -= 0.1
frame = 0
maxspeed = 0.02
maxframesinair = 2.0*(maxspeed/0.0003)
maxbombs = 4
nextbomb = int(maxframesinair/maxbombs)+1
traillength = 4.0
def Update():
    global LavaBombs, frame
    if frame == nextbomb:
        pos = [(random()*3.0)-1.5,0.5,random()*2.0*currentlevelset]
        speed = [0.01*(random()-0.5),maxspeed,0.01*(random()-0.5)]
        LavaBombs.append(LavaBomb(pos,speed))
        if len(LavaBombs) > maxbombs*currentlevelset:
            LavaBombs = LavaBombs[1:]
        frame = 0
    frame += 1
    for b in LavaBombs:
        b.counter += 1
lastpos = [Player1.pos[0],Player1.pos[1],Player1.pos[2]]
def Move():
    global camerarot, lastpos
    Player1.pos[0],Player1.pos[1],Player1.pos[2] = Player1.body.getPosition()
    deltapos = [lastpos[0]-Player1.pos[0],lastpos[1]-Player1.pos[1],lastpos[2]-Player1.pos[2]]
    if Player1.dead or Player1.onplatform:
        s = 128.0
        Player1.body.addForce([s*deltapos[0],0.0,s*deltapos[2]])
    lastpos = [Player1.pos[0],Player1.pos[1],Player1.pos[2]]
    Player1.roll += 4.0*(hypot(deltapos[0],deltapos[2])*360)/pi
    for b in LavaBombs:
        b.previouspositions.append([b.pos[0],b.pos[1],b.pos[2]])
        if len(b.previouspositions) > traillength:
            b.previouspositions = b.previouspositions[1:]
        b.pos[0] += b.speed[0]
        b.pos[1] += b.speed[1]
        b.pos[2] += b.speed[2]
        b.speed[1] -= 0.0003
Blocks = []
LavaBombs = []
ScreenTexture = None
def DrawText(texture,bottomleft):
    TextureShader.pass_texture(texture)
    glBegin(GL_QUADS)
    glTexCoord2f(0,0); glVertex3f(bottomleft[0],bottomleft[1],0.1)
    glTexCoord2f(1,0); glVertex3f(bottomleft[0]+texture.width,bottomleft[1],0.1)
    glTexCoord2f(1,1); glVertex3f(bottomleft[0]+texture.width,bottomleft[1]+texture.height,0.1)
    glTexCoord2f(0,1); glVertex3f(bottomleft[0],bottomleft[1]+texture.height,0.1)
    glEnd()
def MakeText(text,size):
    if   size == 24: surf = Font24.render(text,True,(255,255,255))
    elif size == 36: surf = Font36.render(text,True,(255,255,255))
    return glLibTexture(surf,[0,0,surf.get_width(),surf.get_height()],GLLIB_RGBA,False,GLLIB_FILTER)
def LevelUp(firstlevel=False):
    global Player1, Blocks, LavaBombs, currentlevel, currentlevelset, lastpos, starttime, endtime, tries, score, ScreenTexture
    if currentlevel == 0: firstlevel = True
    if not firstlevel:
        accomplishedsound.play()
        endtime = time.time()
        ScreenTexture = glLibSceneToTexture((0,0,Screen[0],Screen[1]),ScreenTexture)
        i = 0.0
        continuing = True
        textlevelcompleted = MakeText("Level Completed!",36)
        textstats = MakeText("Stats:",24)
        texttime = MakeText("Time: ~"+str(int(round(endtime-starttime)))+" seconds",24)
        timebonus = max([int(round((60-(endtime-starttime))*100)),0])
        levelbonus = currentlevel*100
        triesbonus = -tries*500
        deltascore = timebonus+levelbonus+triesbonus
        score += deltascore
        texttimebonus = MakeText("Time Bonus:         ~"+str(int(round(60-(endtime-starttime))))+" X 100 = "+str(timebonus)+" points",24)
        textlevelbonus = MakeText("Level Bonus:          "+str(currentlevel)+" X 100 = "+str(levelbonus)+" points",24)
        texttriesbonus = MakeText("Tries Deduction:     "+str(tries)+" X -500 = "+str(triesbonus)+" points",24)
        texttotal = MakeText("Total: "+str(deltascore)+" points",24)
        textscore = MakeText("Score: "+str(score)+" points",24)
        while continuing:
            for event in pygame.event.get():
                if event.type == QUIT or (event.type == KEYDOWN and event.key == K_ESCAPE): pygame.quit(); sys.exit()
                if event.type == KEYDOWN and event.key == K_RETURN: continuing = False
            Window.clear()
            View2D.set_view()
            glLibUseShader(TextureShader)
            TextureShader.pass_texture(ScreenTexture)
            TextureShader.pass_float(i,"darkness")
            glLibTexFullScreenQuad()
            TextureShader.pass_float(1.0-i,"darkness")
            DrawText(textlevelcompleted,((Screen[0]/2.0)-200,(Screen[1]/2.0)+100))
            DrawText(textstats,((Screen[0]/2.0)-200,Screen[1]/2.0))
            DrawText(texttime,((Screen[0]/2.0)-150,(Screen[1]/2.0)-50))
            DrawText(texttimebonus,((Screen[0]/2.0)-150,(Screen[1]/2.0)-80))
            DrawText(textlevelbonus,((Screen[0]/2.0)-150,(Screen[1]/2.0)-110))
            DrawText(texttriesbonus,((Screen[0]/2.0)-150,(Screen[1]/2.0)-140))
            DrawText(texttotal,((Screen[0]/2.0)-150,(Screen[1]/2.0)-170))
            DrawText(textscore,((Screen[0]/2.0)-150,(Screen[1]/2.0)-230))
            Window.flip()
            if i < 0.9:
                i += 0.01
        tries = 0
    currentlevel += 1
    if currentlevel == 11: currentlevelset = 2
    if currentlevel == 18: currentlevelset = 3
    farworld.setPosition((0,-9,10+(2*currentlevelset)))
    for b in Blocks:
        b.kill()
        del b
    Blocks = []
    LavaBombs = []
    if   currentlevelset == 1: leveldata = levelset1.levels[currentlevel-1]
    elif currentlevelset == 2: leveldata = levelset2.levels[currentlevel-11]
    elif currentlevelset == 3: leveldata = levelset3.levels[currentlevel-18]
    index = 0
    for block in leveldata:
        if block != 0:
            if block == "S": block = 1.0
            x = (2-(index%4))*third - sixth
            y = block
            z = (2.0*currentlevelset) - ((index/4)*third) - sixth
            Blocks.append(Block([x,y,z]))
        index += 1
    try:Player1.kill()
    except:pass
    Player1 = Player()
    lastpos = [Player1.pos[0],Player1.pos[1],Player1.pos[2]]
    if currentlevel in [1,3,5,20,21]:
        enter = MakeText("[Press ENTER to continue]",24)
        if currentlevel == 1:
            messages = [MakeText("Welcome to Bridge by Ian Mallett!",24),
                        MakeText("The goal of this game is to get to the other side over the bridge.",24),
                        MakeText("Going off the edges means inevitable death...",24),
                        MakeText('Rotate with the "LEFT" and "RIGHT" arrow keys.  Drive with "UP".',24),
                        MakeText("The little green arrow at your feet tells you where you're going.",24),
                        MakeText("This bridge is easy--drive on across!",24)]
        if currentlevel == 3:
            messages = [MakeText("Be careful!  The bridge is slippery!",24)]
        if currentlevel == 5:
            messages = [MakeText("You can use SPACE or SHIFT to jump.",24)]
        if currentlevel == 20:
            messages = [MakeText("Watch out for the different height platforms!",24)]
        if currentlevel == 21:
            messages = [MakeText("CONGRATULATIONS!",24),
                        MakeText("You've beaten my little platformer game!",24),
                        MakeText("Your score is "+str(score),24)]
        continuing = 1
        while continuing <= len(messages):
            Draw(False)
            ScreenTexture = glLibSceneToTexture((0,0,Screen[0],Screen[1]),ScreenTexture)
            View2D.set_view()
            glLibUseShader(TextureShader)
            TextureShader.pass_texture(ScreenTexture)
            TextureShader.pass_float(0.8,"darkness")
            glLibTexFullScreenQuad()
            TextureShader.pass_float(0.0,"darkness")
            DrawText(messages[continuing-1],(50,100))
            DrawText(enter,(50,50))
            MakeText("Welcome to Bridge!",24)
            Window.flip()
            for event in pygame.event.get():
                if event.type == QUIT or (event.type == KEYDOWN and event.key == K_ESCAPE): pygame.quit(); sys.exit()
                if event.type == KEYDOWN and event.key == K_RETURN: continuing += 1
    startsound.play()
    starttime = time.time()
contactgroup = ode.JointGroup()
def near_callback(args, geom1, geom2):
    contacts = ode.collide(geom1, geom2)
    world,contactgroup = args
    for c in contacts:
        c.setBounce(0.1)
        c.setMu(5000)
        j = ode.ContactJoint(world,contactgroup,c)
        j.attach(geom1.getBody(), geom2.getBody())
def CollisionDetect():
    collidespace.collide((world,contactgroup),near_callback)
    world.step(1.0/40.0)
    contactgroup.empty()
    Player1.onplatform = False
    if   abs(Player1.pos[1]-1.0417163372) < 0.001: Player1.onplatform = True
    elif abs(Player1.pos[1]-0.941716134548) < 0.001: Player1.onplatform = True
    elif abs(Player1.pos[1]-1.1417163372) < 0.001: Player1.onplatform = True
    if Player1.pos[1] <= 0.5:
        if not Player1.dead:
            explosionsound.play()
            Player1.dead = True
    if Player1.pos[2] >= (2.0*currentlevelset) + 0.1 and Player1.onplatform:
        LevelUp()
glLibUseMaterial("Silver")
def Draw(flip=True):
    Window.clear()
    View3D.set_view()
    
    camerapos = [Player1.pos[0],Player1.pos[1]+(cameraradius*sin(radians(camerarot))),Player1.pos[2]-(cameraradius*cos(radians(camerarot)))]
    gluLookAt(camerapos[0],camerapos[1],camerapos[2],
              Player1.pos[0],Player1.pos[1],Player1.pos[2],
              0,1,0)

    glLightfv(GL_LIGHT0,GL_POSITION,[0,-100,0,1])
    glLightfv(GL_LIGHT1,GL_POSITION,[0,100,0,1])
    glLightfv(GL_LIGHT2,GL_POSITION,[Player1.pos[0],Player1.pos[1],Player1.pos[2],1])

    #World
    glLibUseShader(LightTextureShader)
    LightTextureShader.pass_float(8.0,"uvscale")
    LightTextureShader.pass_texture(RockTexture)
    #   Near Side
    glPushMatrix();glTranslatef(0,-9,-10);glScalef(10,10,10);glCallList(cube);glPopMatrix()
    #   Far Side
    glPushMatrix();glTranslatef(0,-9,10+(2*currentlevelset));glScalef(10,10,10);glCallList(cube);glPopMatrix()
    #   Lava
    LightTextureShader.pass_texture(LavaTexture)
    glPushMatrix();glTranslatef(0,0.5,0);glScalef(10,10,10);glNormal3f(0,-1,0);glCallList(plane);glPopMatrix()
    #   Bridge
    LightTextureShader.pass_float(1.0,"uvscale")
    LightTextureShader.pass_texture(PlatformTexture)
    glNormal3f(0,1,0)
    for b in Blocks: b.draw()
    #   Sky
    glLibUseShader(TextureShader)
    TextureShader.pass_texture(SkyTexture)
    TextureShader.pass_float(6.0,"uvscale")
    glPushMatrix();glRotatef(90,1,0,0);glCallList(SkySphere.list);glPopMatrix()
    
    #Player
    if not Player1.dead:
        TextureShader.pass_texture(ArrowTexture)
        TextureShader.pass_float(1.0,"uvscale")
        glPushMatrix();glTranslatef(Player1.pos[0]-0.099*cos(radians(Player1.direction-90)),Player1.pos[1]-twentyfourth+0.01,Player1.pos[2]-0.099*sin(radians(Player1.direction-90)));glRotatef(-Player1.direction,0,1,0);glCallList(arrow);glPopMatrix()
        glLightfv(GL_LIGHT1,GL_DIFFUSE,[0.3,0.3,0.3,1])
        glLightfv(GL_LIGHT1,GL_SPECULAR,[0.3,0.3,0.3,1])
        if Player1.onplatform:
            glLightfv(GL_LIGHT0,GL_DIFFUSE,[0,0,0,1])
            glLightfv(GL_LIGHT0,GL_SPECULAR,[0,0,0,1])
        glLibUseShader(NormalShader)
        NormalShader.pass_float(1.0,"uvscale")
        NormalShader.pass_texture(PlayerTexture)
        NormalShader.pass_normalmap(PlayerNormalTexture)
        Player1.draw()
        glLightfv(GL_LIGHT0,GL_DIFFUSE,[1,1,1,1])
        glLightfv(GL_LIGHT0,GL_SPECULAR,[1,1,1,1])
        inten = 0.005
        glLightfv(GL_LIGHT1,GL_DIFFUSE,[inten,inten,inten,1])
        glLightfv(GL_LIGHT1,GL_SPECULAR,[inten,inten,inten,1])
    #Lava Bombs
    glLibUseShader(TextureShader)
    TextureShader.pass_texture(LavaBombTrailTexture)
    TextureShader.pass_float(1.0,"uvscale")
    glLibSelectTexture(LavaBombTrailTexture)
    for b in LavaBombs:
        if b.speed[2] < 0:  indices = range(0,len(b.previouspositions),1)
        else:               indices = range(len(b.previouspositions)-1,-1,-1)
        for i in indices:
            glPushMatrix();pos = b.previouspositions[i];glTranslatef(*pos);glRotatef(-degrees(atan2(camerapos[2]-pos[2],camerapos[0]-pos[0]))+90,0,1,0);glRotatef(degrees(atan2(camerapos[1]-pos[1],camerapos[2]-pos[2])),1,0,0);glScalef(*[i/traillength]*3);glCallList(LavaBombTrail);glPopMatrix()
            i += 1
    TextureShader.pass_texture(LavaTexture)
    for b in LavaBombs:
        b.draw()
    
    if flip:
        Window.flip()
fps = 0.0
explosionsound = pygame.mixer.Sound("data/sound/explosion.ogg")
explosionsound.set_volume(0.3)
accomplishedsound = pygame.mixer.Sound("data/sound/accomplished.ogg")
startsound = pygame.mixer.Sound("data/sound/start.ogg")
def main():
    pygame.mixer.music.load("data/sound/music.ogg")
    pygame.mixer.music.play(-1)
    global fps
    Clock = pygame.time.Clock()
    LevelUp()
    while True:
        GetInput()
        Update()
        Move()
        CollisionDetect()
        Draw()
        Clock.tick(40)
        fps = Clock.get_fps()
##    import time
##    while True:
##        t1 = time.time()
##        for x in xrange(10):
##            Draw()
##        t2 = time.time()
##        print "fps: %f" % round(1.0/((t2-t1)/10.0),2)
if __name__ == '__main__':
    glLibTestErrors(main)
