from glLib import *
from const import *
import ode
def send(data):
    global LavaSphere,PlayerSphere,platform,collidespace,world
    LavaSphere,PlayerSphere,platform,collidespace,world = data
class Player:
    def __init__(self):
        self.pos = [0,1+0.1+twentyfourth,-0.1]
        self.maxspeed = 0.02
        self.direction = 0
        self.roll = 0
        self.dead = False
        self.onplatform = True
        
        self.body = ode.Body(world)
        M = ode.Mass()
        M.setSphere(2500.0, 0.05)
        self.body.setMass(M)
        self.body.setPosition((self.pos[0],self.pos[1],self.pos[2]))
        self.geom = ode.GeomSphere(collidespace,twentyfourth)
        self.geom.setBody(self.body)
    def kill(self):
        self.body.disable()
        self.geom.disable()
    def draw(self):
        glPushMatrix()
        glTranslatef(*self.pos)
        glRotatef(-self.direction+90,0,1,0)
        glRotatef(self.roll,0,0,1)
        glCallList(PlayerSphere.list)
        glPopMatrix()
class LavaBomb:
    def __init__(self,pos,speed):
        self.pos = pos
        self.speed = speed
        self.previouspositions = []
        self.counter = 0
    def draw(self):
        glPushMatrix()
        glTranslatef(*self.pos)
        glCallList(LavaSphere.list)
        glPopMatrix()
class Block:
    def __init__(self,pos):
        self.pos = pos
        self.negpos = [-pos[0],-pos[1],-pos[2]]
        self.speed = 0.0
        self.geom = ode.GeomBox(collidespace, lengths=(third,0.0001,third))
        self.geom.setPosition(self.pos)
    def kill(self):
        self.geom.disable()
    def draw(self):
        glTranslatef(*self.pos)
        glCallList(platform)
        glTranslatef(*self.negpos)
