from glLib import *

NormalShader = glLibShader()
NormalShader.user_variables("uniform float uvscale;")
NormalShader.render_equation("""
vec4 texsample = tex(tex1,uv);
vec4 diffuse = diffuse_light0_factor_nm+diffuse_light1_factor_nm+(light2_att*diffuse_light2_factor_nm);
vec4 specular = blinn_specular_light0_factor_nm+blinn_specular_light1_factor_nm+(light2_att*blinn_specular_light2_factor_nm);
color += diffuse*texsample;
color += specular*texsample;""")
NormalShader.uv_transform("uv *= uvscale;")
NormalShader.compile()

TextureShader = glLibShader()
TextureShader.user_variables("uniform float uvscale;uniform float darkness;")
TextureShader.render_equation("""
color = tex(tex1,uv);
color.rgb *= 1.0-darkness;""")
TextureShader.uv_transform("uv *= uvscale;")
TextureShader.compile()

LightTextureShader = glLibShader()
LightTextureShader.user_variables("uniform float uvscale;")
LightTextureShader.render_equation("""
vec4 texsample = tex(tex1,uv);
vec4 diffuse = diffuse_light0_factor+diffuse_light1_factor+(light2_att*diffuse_light2_factor);
vec4 specular = blinn_specular_light0_factor+blinn_specular_light1_factor+(light2_att*blinn_specular_light2_factor);
color = (diffuse*texsample)+(specular*texsample);""")
LightTextureShader.uv_transform("uv *= uvscale;")
LightTextureShader.compile()


##errors = LightTextureShader.get_errors()
##if errors != "":pygame.quit();raw_input(errors);sys.exit()
##print "No errors to report!"
