from glLibLocals import *
from glLibShader import glLibUseShader
from glLibTexturing import glLibActiveTexture
from glLibMisc import *
from glLibView import *
from glLibObjects import glLibTexFullScreenQuad
from glLibPrebuiltShaders import *
specialview1 = glLibView2D((0,0,1,1))
def glLibBlur(rect,shader,radius,uvstep):
    currenttexture = glGetIntegerv(GL_ACTIVE_TEXTURE) - GL_TEXTURE0

    glLibActiveTexture(9)
    shader.special1tex1 = glLibSceneToTexture(rect,shader.special1tex1)

    specialview1.rect = rect
    specialview1.set_view()

    glLibUseShader(shader)
    
    glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT)
    glLoadIdentity()
    glBindTexture(GL_TEXTURE_2D,shader.special1tex1.texture)
    glUniform1i(glGetUniformLocation(shader.program,"scenebuffertex1"),9)
    shader.pass_int(1,"stage")
    shader.pass_vec2(uvstep,"uvstep")
    shader.pass_int(radius,"size")
    glLibTexFullScreenQuad()

    glLibActiveTexture(10)
    shader.special1tex2 = glLibSceneToTexture(rect,shader.special1tex2)
    glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT)
    glLoadIdentity()
    glBindTexture(GL_TEXTURE_2D,shader.special1tex2.texture)
    glUniform1i(glGetUniformLocation(shader.program,"scenebuffertex2"),10)
    shader.pass_int(2,"stage")
    glLibTexFullScreenQuad()

    glLibActiveTexture(currenttexture)
specialview2 = glLibView2D((0,0,1,1))
def glLibRadialBlur(rect,shader,center,size,step):
    currenttexture = glGetIntegerv(GL_ACTIVE_TEXTURE) - GL_TEXTURE0

    glLibActiveTexture(5)
    shader.special2tex1 = glLibSceneToTexture(rect,shader.special2tex1)

    specialview2.rect = rect
    specialview2.set_view()

    glLibUseShader(shader)
    
    glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT)
    glLoadIdentity()
    glBindTexture(GL_TEXTURE_2D,shader.special2tex1.texture)
    glUniform1i(glGetUniformLocation(shader.program,"scenebuffertex"),5)
    shader.pass_int(size,"size")
    shader.pass_float(step,"step")
    shader.pass_vec2(center,"center")
    glLibTexFullScreenQuad()

    glLibActiveTexture(currenttexture)
specialview3 = glLibView2D((0,0,1,1))
def glLibThreshold(texture,shader,lowthreshold,highthreshold,replacecolor):
    currenttexture = glGetIntegerv(GL_ACTIVE_TEXTURE) - GL_TEXTURE0

    glLibActiveTexture(5)
    shader.special3tex1 = glLibSceneToTexture(texture.rect,shader.special3tex1)

    specialview3.rect = texture.rect
    specialview3.set_view()

    glLibUseShader(shader)
    
    glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT)
    glLoadIdentity()
    glBindTexture(GL_TEXTURE_2D,shader.special3tex1.texture)
    glUniform1i(glGetUniformLocation(shader.program,"scenebuffertex"),5)
    shader.pass_vec4(lowthreshold,"lowthreshold")
    shader.pass_vec4(highthreshold,"highthreshold")
    shader.pass_vec4(replacecolor,"replacecolor")
    glLibTexFullScreenQuad()

    glLibActiveTexture(currenttexture)
def glLibOutline(drawfunc,linewidth):
    oldlinewidth = glGetIntegerv(GL_LINE_WIDTH)
    oldcullenable = glGetBooleanv(GL_CULL_FACE)
    oldcullside = glGetIntegerv(GL_CULL_FACE_MODE)
    glLineWidth(linewidth)
    glEnable(GL_CULL_FACE)
    glCullFace(GL_FRONT)
    glPolygonMode(GL_FRONT_AND_BACK,GL_LINE)
    drawfunc()
    glPolygonMode(GL_FRONT_AND_BACK,GL_FILL)
    if oldcullside == GL_BACK: glCullFace(GL_BACK)
    if not oldcullenable: glDisable(GL_CULL_FACE)
    glLineWidth(oldlinewidth)
def glLibMakeShadowMap(LightPosition,LightView,NormalView,depthmap,drawoccluders):
    glPushMatrix()
    LightView.set_view()
    LightProjectionMatrix = glGetFloatv(GL_PROJECTION_MATRIX)
    glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT)
    glLoadIdentity()
    gluLookAt(LightPosition[0],LightPosition[1],LightPosition[2],0,0,0,0,1,0)
    LightViewMatrix = glGetFloatv(GL_MODELVIEW_MATRIX)
    
    glEnable(GL_POLYGON_OFFSET_FILL)
    glPolygonOffset(1,1)
    drawoccluders()
    glLibActiveTexture(8);depthmap=glLibSceneToShadowMap(LightView.rect[2],depthmap);glLibActiveTexture(0)
    glPolygonOffset(0,0)
    glDisable(GL_POLYGON_OFFSET_FILL)
    
    glPopMatrix()
    NormalView.set_view()
    return depthmap, LightProjectionMatrix, LightViewMatrix
def glLibDrawWithShadowMaps(shadowmaps,ShadowShader):
    glLibUseShader(ShadowShader)
    index = 8
    glPushMatrix()
    for shadowmap in shadowmaps:
        glLibActiveTexture(index)
        ShadowShader.pass_shadow_texture(shadowmap[0])
        glPushMatrix()
        glLoadMatrixf([[0.5,0.0,0.0,0.0],
                       [0.0,0.5,0.0,0.0],
                       [0.0,0.0,0.5,0.0],
                       [0.5,0.5,0.5,1.0]])
        glMultMatrixf(shadowmap[1])
        glMultMatrixf(shadowmap[2])
        ShadowShader.pass_mat4(glGetFloatv(GL_MODELVIEW_MATRIX),"texture%i"%(index-7))
        glPopMatrix()
        index += 1
    glPopMatrix()
    glLibActiveTexture(0)
