from glLibLocals import *
class glLibTexture:
    def __init__(self,data,rect,format,mipmapping,filtering,colorkey=None):
        self.x = rect[0]
        self.y = rect[1]
        self.width = rect[2]
        self.height = rect[3]
        self.rect = rect
        self.format = format
        #Get Data
        if type(data) == type(""):
            data = pygame.image.load(os.path.join(*data.split("/"))).convert_alpha()
            data = data.subsurface((0,0,self.width,self.height))
        if colorkey != None:
            data.set_colorkey(colorkey)
        if data not in [None,GLLIB_FBCOPY]:
            if format == GLLIB_RGB:
                data = pygame.image.tostring(data,"RGB",True)
            else:
                data = pygame.image.tostring(data,"RGBA",True)
        #Create Texture
        self.texture = glGenTextures(1)
        glBindTexture(GL_TEXTURE_2D,self.texture)
        #Internal Format
        if format == GLLIB_RGB:
            self.format = GL_RGB
        elif format == GLLIB_RGBA:
            self.format = GL_RGBA
        elif format == GLLIB_DEPTH:
            self.format = GL_DEPTH_COMPONENT
        #Anisotropy
    ##    glTexParameteri(GL_TEXTURE_2D, GL_GENERATE_MIPMAPS_SGIS)
    ##    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAX_ANISOTROPY_EXT, 16)
        #Mag filter
        if filtering == GLLIB_FILTER:
            glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR)
        else:
            glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST)
        #Create Texture: Min filter and Mipmapping
        if data == GLLIB_FBCOPY:
            glCopyTexImage2D(GL_TEXTURE_2D,0,self.format,self.x,self.y,self.width,self.height,0)
        if mipmapping in [GLLIB_MIPMAP,GLLIB_MIPMAP_BLEND]:
            if mipmapping == GLLIB_MIPMAP_BLEND:
                if filtering == GLLIB_FILTER:
                    mipmap_param = GL_LINEAR_MIPMAP_LINEAR
                else:
                    mipmap_param = GL_NEAREST_MIPMAP_LINEAR
            elif mipmapping == GLLIB_MIPMAP:
                if filtering == GLLIB_FILTER:
                    mipmap_param = GL_LINEAR_MIPMAP_NEAREST
                else:
                    mipmap_param = GL_NEAREST_MIPMAP_NEAREST
            glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,mipmap_param)
            glPixelStoref(GL_UNPACK_ALIGNMENT,1)
            gluBuild2DMipmaps(GL_TEXTURE_2D,3,self.width,self.height,self.format,GL_UNSIGNED_BYTE,data)
        else:
            if filtering == GLLIB_FILTER:
                glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR)
            else:
                glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST)
            glTexImage2D(GL_TEXTURE_2D,0,self.format,self.width,self.height,0,self.format,GL_UNSIGNED_BYTE,data)
    def edge(self,value):
        glBindTexture(GL_TEXTURE_2D,self.texture)
        if value == GLLIB_CLAMP:
            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE)
            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE)
        elif value == GLLIB_REPEAT:
            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT)
            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT)
##        if "shadowtex" in filters:
##            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_COMPARE_MODE_ARB, GL_COMPARE_R_TO_TEXTURE_ARB)
##            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_COMPARE_FUNC_ARB, GL_LEQUAL)
def glLibActiveTexture(texture_number):
    glActiveTexture(GL_TEXTURE0+texture_number);
def glLibSelectTexture(texture):
    glBindTexture(GL_TEXTURE_2D,texture.texture)
