from glLibLocals import *
import glLibInit
class glLibWindow:
    def __init__(self,size,fullscreen=False,icon=None,caption="glLib Window",multisample=False,position=False):
        self.size = size
        if icon == None:icon = pygame.Surface((1,1)); icon.set_alpha(0)
        pygame.display.set_icon(icon)
        pygame.display.set_caption(caption)
        self.multisample = multisample
        self.fullscreen = fullscreen
        if position != False:
            if position == "Center": os.environ['SDL_VIDEO_CENTERED'] = '1'
            else: os.environ['SDL_VIDEO_WINDOW_POS'] = str(position[0])+","+str(position[1])
        if self.multisample:pygame.display.gl_set_attribute(GL_MULTISAMPLEBUFFERS,1)
        else:pygame.display.gl_set_attribute(GL_MULTISAMPLEBUFFERS,0)
        self.set_fullscreen(self.fullscreen)
        self.clear_color = (0,0,0)
        glLibInit.main()
    def set_clear_color(self,color):
        if self.clear_color != color:
            glClearColor(color[0]/255.0,color[1]/255.0,color[2]/255.0,1.0)
            self.clear_color = (color[0],color[1],color[2])
    def clear(self):
        glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT)
        glLoadIdentity()
    def flip(self):
        pygame.display.flip()
    def toggle_fullscreen(self):
        self.fullscreen = not self.fullscreen
        self.set_fullscreen(self.fullscreen)
    def set_fullscreen(self,value):
        if value:self.screenflags = OPENGL|DOUBLEBUF|FULLSCREEN; self.fullscreen = True
        else:self.screenflags = OPENGL|DOUBLEBUF; self.fullscreen = False
        pygame.display.set_mode(self.size,self.screenflags)
